export interface IResult {
    fieldCount: number;
    affectedRows: number;
    insertId: number;
    serverStatus: number;
    warningCount: number;
    message: string;
    protocol41: boolean;
    changedRows: number;
}
export interface ICount extends Promise<number> {
    where(condiction: string): ICount;
    where(...condictions: object[]): ICount;
}
export interface ISelect<T> extends Promise<T[]> {
    from(table: string): ISelect<T>;
    where(condiction: string): ISelect<T>;
    where(...condictions: object[]): ISelect<T>;
    groupBy(column: string): ISelect<T>;
    orderBy(...orders: Array<[string, number]>): ISelect<T>;
    limit(limit: number): ISelect<T>;
    offset(offset: number): ISelect<T>;
}
export interface IInsert extends Promise<IResult> {
    values(values: object[]): IInsert;
}
export interface IDelete extends Promise<IResult> {
    where(condiction: string): IDelete;
    where(...condictions: object[]): IDelete;
    limit(limit: number): IDelete;
    offset(offset: number): IDelete;
}
export interface IUpdate extends Promise<IResult> {
    where(condiction: string): IUpdate;
    where(...condictions: object[]): IUpdate;
    set(value: object): IUpdate;
    set(values: object[], by: any): IUpdate;
}
export declare function select<T>(columns: string[] | string, exec: (sql: any, resolve: any, reject: any) => void): ISelect<T>;
export declare function count(table: string, exec: (sql: any, resolve: any, reject: any) => void): ICount;
export declare function insertInto(table: any, exec: (sql: any, resolve: any, reject: any) => void): IInsert;
export declare function deleteFrom(table: string, exec: (sql: any, resolve: any, reject: any) => void): IDelete;
export declare function update(table: string, exec: (sql: any, resolve: any, reject: any) => void): IUpdate;
